source: branches/8.09/package/madwifi/files/lib/wifi/madwifi.sh @ 13014

Last change on this file since 13014 was 13014, checked in by nbd, 8 years ago

sync 8.09 with changes from trunk

  • Property svn:eol-style set to native
  • Property svn:executable set to *
File size: 7.7 KB
Line 
1#!/bin/sh
2append DRIVERS "atheros"
3
4scan_atheros() {
5        local device="$1"
6        local wds
7        local adhoc sta ap
8       
9        config_get vifs "$device" vifs
10        for vif in $vifs; do
11       
12                config_get ifname "$vif" ifname
13                config_set "$vif" ifname "${ifname:-ath}"
14               
15                config_get mode "$vif" mode
16                case "$mode" in
17                        adhoc|ahdemo|sta|ap|monitor)
18                                append $mode "$vif"
19                        ;;
20                        wds)
21                                config_get ssid "$vif" ssid
22                                [ -z "$ssid" ] && continue
23
24                                config_set "$vif" wds 1
25                                config_set "$vif" mode sta
26                                mode="sta"
27                                addr="$ssid"
28                                ${addr:+append $mode "$vif"}
29                        ;;
30                        *) echo "$device($vif): Invalid mode, ignored."; continue;;
31                esac
32        done
33
34        case "${adhoc:+1}:${sta:+1}:${ap+1}" in
35                # valid mode combinations
36                1::) wds="";;
37                1::1);;
38                :1:1)config_set "$device" nosbeacon 1;; # AP+STA, can't use beacon timers for STA
39                :1:);;
40                ::1);;
41                ::);;
42                *) echo "$device: Invalid mode combination in config"; return 1;;
43        esac
44
45        config_set "$device" vifs "${ap:+$ap }${adhoc:+$adhoc }${ahdemo:+$ahdemo }${sta:+$sta }${wds:+$wds }${monitor:+$monitor}"
46}
47
48
49disable_atheros() (
50        local device="$1"
51
52        set_wifi_down "$device"
53        # kill all running hostapd and wpa_supplicant processes that
54        # are running on atheros vifs
55        for pid in `pidof hostapd wpa_supplicant`; do
56                grep ath /proc/$pid/cmdline >/dev/null && \
57                        kill $pid
58        done
59       
60        include /lib/network
61        cd /proc/sys/net
62        for dev in *; do
63                grep "$device" "$dev/%parent" >/dev/null 2>/dev/null && {
64                        ifconfig "$dev" down
65                        unbridge "$dev"
66                        wlanconfig "$dev" destroy
67                }
68        done
69        return 0
70)
71
72enable_atheros() {
73        local device="$1"
74        config_get channel "$device" channel
75        config_get vifs "$device" vifs
76
77        [ auto = "$channel" ] && channel=0
78
79        local first=1
80        for vif in $vifs; do
81                local start_hostapd
82                nosbeacon=
83                config_get ifname "$vif" ifname
84                config_get enc "$vif" encryption
85                config_get eap_type "$vif" eap_type
86                config_get mode "$vif" mode
87               
88                case "$mode" in
89                        sta) config_get nosbeacon "$device" nosbeacon;;
90                        adhoc) config_get nosbeacon "$vif" sw_merge;;
91                esac
92               
93                config_get ifname "$vif" ifname
94                ifname=$(wlanconfig "$ifname" create wlandev "$device" wlanmode "$mode" ${nosbeacon:+nosbeacon})
95                [ $? -ne 0 ] && {
96                        echo "enable_atheros($device): Failed to set up $mode vif $ifname" >&2
97                        continue
98                }
99                config_set "$vif" ifname "$ifname"
100
101                # only need to change freq band and channel on the first vif
102                config_get agmode "$device" agmode
103                [ -z "$agmode" ] && config_get agmode "$device" mode
104
105                pureg=0
106                case "$agmode" in
107                        *b) agmode=11b;;
108                        *bg) agmode=11g;;
109                        *g) agmode=11g; pureg=1;;
110                        *gdt) agmode=11gdt;;
111                        *a) agmode=11a;;
112                        *adt) agmode=11adt;;
113                        *ast) agmode=11ast;;
114                        *fh) agmode=fh;;
115                        *) agmode=auto;;
116                esac
117                iwpriv "$ifname" mode "$agmode"
118                iwpriv "$ifname" pureg "$pureg"
119
120                [ "$first" = 1 ] && {
121                        iwconfig "$ifname" channel "$channel" >/dev/null 2>/dev/null
122                }
123       
124                config_get_bool hidden "$vif" hidden 0
125                iwpriv "$ifname" hide_ssid "$hidden"
126
127                config_get ff "$vif" ff
128                if [ -n "$ff" ]; then
129                        iwpriv "$ifname" ff "$ff"
130                fi
131
132                config_get wds "$vif" wds
133                case "$wds" in
134                        1|on|enabled) wds=1;;
135                        *) wds=0;;
136                esac
137                iwpriv "$ifname" wds "$wds"
138
139                [ "$mode" = ap -a "$wds" = 1 ] && {
140                        config_get_bool wdssep "$vif" wdssep 1
141                        [ -n "$wdssep" ] && iwpriv "$ifname" wdssep "$wdssep"
142                }
143
144                case "$enc" in
145                        WEP|wep)
146                                for idx in 1 2 3 4; do
147                                        config_get key "$vif" "key${idx}"
148                                        iwconfig "$ifname" enc "[$idx]" "${key:-off}"
149                                done
150                                config_get key "$vif" key
151                                key="${key:-1}"
152                                case "$key" in
153                                        [1234]) iwconfig "$ifname" enc "[$key]";;
154                                        *) iwconfig "$ifname" enc "$key";;
155                                esac
156                        ;;
157                        psk*|wpa*)
158                                start_hostapd=1
159                                config_get key "$vif" key
160                        ;;
161                esac
162
163                case "$mode" in
164                        adhoc|ahdemo)
165                                config_get addr "$vif" bssid
166                                [ -z "$addr" ] || { 
167                                        iwconfig "$ifname" ap "$addr"
168                                }
169                        ;;
170                esac
171                config_get ssid "$vif" ssid
172
173                config_get_bool bgscan "$vif" bgscan
174                [ -n "$bgscan" ] && iwpriv "$ifname" bgscan "$bgscan"
175
176                config_get_bool antdiv "$device" diversity
177                [ -n "$antdiv" ] && sysctl -w dev."$device".diversity="$antdiv" >&-
178
179                config_get antrx "$device" rxantenna
180                [ -n "$antrx" ] && sysctl -w dev."$device".rxantenna="$antrx" >&-
181
182                config_get anttx "$device" txantenna
183                [ -n "$anttx" ] && sysctl -w dev."$device".txantenna="$anttx" >&-
184
185                config_get distance "$device" distance
186                [ -n "$distance" ] && athctrl -i "$device" -d "$distance" >&-
187
188                config_get_bool softled "$device" softled 1
189                [ -n "$softled" ] && sysctl -w dev."$device".softled="$softled" >&-
190
191                config_get txpwr "$vif" txpower
192                [ -n "$txpwr" ] && iwconfig "$ifname" txpower "${txpwr%%.*}"
193
194                config_get rate "$vif" rate
195                [ -n "$rate" ] && iwconfig "$ifname" rate "${rate%%.*}"
196
197                config_get mcast_rate "$vif" mcast_rate
198                [ -n "$mcast_rate" ] && iwpriv "$ifname" mcast_rate "${mcast_rate%%.*}"
199
200                config_get frag "$vif" frag
201                [ -n "$frag" ] && iwconfig "$ifname" frag "${frag%%.*}"
202
203                config_get rts "$vif" rts
204                [ -n "$rts" ] && iwconfig "$ifname" rts "${rts%%.*}"
205
206                config_get_bool comp "$vif" compression
207                [ -n "$comp" ] && iwpriv "$ifname" compression "$comp"
208
209                config_get_bool minrate "$vif" minrate
210                [ -n "$minrate" ] && iwpriv "$ifname" minrate "$minrate"
211
212                config_get_bool maxrate "$vif" maxrate
213                [ -n "$maxrate" ] && iwpriv "$ifname" maxrate "$maxrate"
214
215                config_get_bool burst "$vif" bursting
216                [ -n "$burst" ] && iwpriv "$ifname" burst "$burst"
217
218                config_get_bool wmm "$vif" wmm
219                [ -n "$wmm" ] && iwpriv "$ifname" wmm "$wmm"
220
221                config_get_bool xr "$vif" xr
222                [ -n "$xr" ] && iwpriv "$ifname" xr "$xr"
223
224                config_get_bool ar "$vif" ar
225                [ -n "$ar" ] && iwpriv "$ifname" ar "$ar"
226
227                config_get_bool turbo "$vif" turbo
228                [ -n "$turbo" ] && iwpriv "$ifname" turbo "$turbo"
229
230                config_get_bool doth "$vif" doth 0
231                [ -n "$doth" ] && iwpriv "$ifname" doth "$doth"
232
233                config_get maclist "$vif" maclist
234                [ -n "$maclist" ] && {
235                        # flush MAC list
236                        iwpriv "$ifname" maccmd 3
237                        for mac in $maclist; do
238                                iwpriv "$ifname" addmac "$mac"
239                        done
240                }
241
242                config_get macpolicy "$vif" macpolicy
243                case "$macpolicy" in
244                        allow)
245                                iwpriv "$ifname" maccmd 1
246                        ;;
247                        deny)
248                                iwpriv "$ifname" maccmd 2
249                        ;;
250                        *)
251                                # default deny policy if mac list exists
252                                [ -n "$maclist" ] && iwpriv "$ifname" maccmd 2
253                        ;;
254                esac
255
256                ifconfig "$ifname" up
257                local net_cfg bridge
258                net_cfg="$(find_net_config "$vif")"
259                [ -z "$net_cfg" ] || {
260                        bridge="$(bridge_interface "$net_cfg")"
261                        config_set "$vif" bridge "$bridge"
262                        start_net "$ifname" "$net_cfg"
263                }
264                [ -n "$ssid" ] && iwconfig "$ifname" essid on
265                iwconfig "$ifname" essid "$ssid"
266                set_wifi_up "$vif" "$ifname"
267                case "$mode" in
268                        ap)
269                                config_get_bool isolate "$vif" isolate 0
270                                iwpriv "$ifname" ap_bridge "$((isolate^1))"
271
272                                if [ -n "$start_hostapd" ] && eval "type hostapd_setup_vif" 2>/dev/null >/dev/null; then
273                                        hostapd_setup_vif "$vif" madwifi || {
274                                                echo "enable_atheros($device): Failed to set up hostapd for interface $ifname" >&2
275                                                # make sure this wifi interface won't accidentally stay open without encryption
276                                                ifconfig "$ifname" down
277                                                wlanconfig "$ifname" destroy
278                                                continue
279                                        }
280                                fi
281                        ;;
282                        wds|sta)
283                                if eval "type wpa_supplicant_setup_vif" 2>/dev/null >/dev/null; then
284                                        wpa_supplicant_setup_vif "$vif" madwifi || {
285                                                echo "enable_atheros($device): Failed to set up wpa_supplicant for interface $ifname" >&2
286                                                ifconfig "$ifname" down
287                                                wlanconfig "$ifname" destroy
288                                                continue
289                                        }
290                                fi
291                        ;;
292                esac
293                first=0
294        done
295}
296
297
298detect_atheros() {
299        cd /proc/sys/dev
300        [ -d ath ] || return
301        for dev in $(ls -d wifi* 2>&-); do
302                config_get type "$dev" type
303                [ "$type" = atheros ] && return
304                cat <<EOF
305config wifi-device  $dev
306        option type     atheros
307        option channel  auto
308
309        # REMOVE THIS LINE TO ENABLE WIFI:
310        option disabled 1
311
312config wifi-iface
313        option device   $dev
314        option network  lan
315        option mode     ap
316        option ssid     OpenWrt
317        option encryption none
318EOF
319        done
320}
Note: See TracBrowser for help on using the repository browser.